import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class InvMatrix extends Frame
{  public InvMatrix()
   {  setSize(800,300);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public void MultM(double [][] A,double [][] B,double [][] C,int N1,int N2, int N3)
   {  int i,j,k;
      for(i=0;i<N1;i++) for(j=0;j<N3; j++)
      {  C[i][j]=0.0;
         for(k=0;k<N2;k++) C[i][j] += A[i][k] * B[k][j];
      }
   }
   public void MoveM(double [][] A,double [][] B,int jst,int N1,int N2)
   {  int i,j;
      for(i=0;i<N1;i++) for(j=0;j<N2; j++)B[i][j]=A[i][j+jst];
   }
   public int InvMat(double [][] A, int N, double Eps)
   {   int i,j,k; double Alfa;int N2 = N * 2;    
       for(i=0;i<N;i++)for(j=0;j<N;j++) A[i][j+N] = (i==j ? 1 : 0);
       for(k = 0; k < N; k++)       
       { if(Math.abs(A[k][k]) < Eps) return 1;
         Alfa=1/A[k][k];int k1=k+1;
         for(j=k1;j<N2;j++) A[k][j] *= Alfa;
         for(i=0;i<N;i++)
            if(i != k)
            { Alfa=A[i][k];
              for(j=k1;j<N2;j++) A[i][j] -= Alfa* A[k][j];
            }
       } 
       return 0;
   }
   public void drawBra(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X + 2,Y);g.drawLine( X,Y + H, X + 2, Y + H);
   }
   public void drawKet(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X - 2,Y);g.drawLine( X,Y + H, X - 2, Y + H);
   }
   private double round(double D,int N)
   {  
      double DN=10*Math.pow(10.0,(double)(N-1));
      if(Math.abs(D*DN)<0.5) return 0.0;
      return (Math.rint(D*DN))/DN;
   }
   public void DrawData(Graphics g, int Y, double [][] A,int N)
   {  int i, j;
      for(i=0;i<N;i++)
      {
         for(j=0;j<N; j++)
         {  int k =j + N;
            g.drawString( "" + round(A[i][j],3), 50 + j * 50,Y + i * 20);
            g.drawString( "" + round(A[i][k],3),350 + j * 50,Y + i * 20);
         }
      }
      drawBra(g, 40, Y - 10, 50); drawKet(g,190, Y - 10, 50);
      drawBra(g,340, Y - 10, 50); drawKet(g,490, Y - 10, 50);
   } 

   public void DrawMat(Graphics g, String ope1,String ope2, int Y,
                       double [][] A,double [][] B,double [][] C,int N1,int N2)
   {  int i, j;
      g.drawString( ope1,205,Y+20);
      g.drawString( ope2,400,Y+20);
      for(i=0;i<N1;i++)
      { for(j=0;j<N2; j++)
        { g.drawString( "" + round(A[i][j],3), 50 + j*50, Y + i*20);
          g.drawString( "" + round(B[i][j],3),235 + j*50, Y + i*20);
          g.drawString( "" + round(C[i][j],3),450 + j*50, Y + i*20);
        }
      }  
      drawBra(g, 40, Y - 10, 50); drawKet(g,190, Y - 10, 50);
      drawBra(g,230, Y - 10, 50); drawKet(g,390, Y - 10, 50);
      drawBra(g,445, Y - 10, 50); drawKet(g,590, Y - 10, 50);
   } 
   public void paint(Graphics g)
   {  int i,j;
      double [][] A={{3,2,1,1,0,0},{-5,-8,-1,0,1,0},{-2,-4,7,0,0,1}};
      double [][] B={{0,0,0},{0,0,0},{0,0,0}};
      double [][] C={{0,0,0},{0,0,0},{0,0,0}};
      double [][] D={{0,0,0},{0,0,0},{0,0,0}};
      setTitle("tsi|o@ɂj");
      g.drawString( "f[^",20,50);
      DrawData(g, 80, A, 3);
      MoveM(A,B,0,3,3);
      InvMat(A, 3, 0.000001);
      MoveM(A,C,3,3,3);
      g.drawString( "mF",20,150);
      MultM(B,C,D, 3, 3, 3);
      DrawMat(g, "","", 180, B, C, D, 3,3);
   } 
   public static void main(String[] args)
   {  Frame w = new InvMatrix();
      w.setVisible(true);
   }
}
